#!/bin/python
#####################################################################
# Python Tutorial
# by: Benjamin Morgan
# Basic tutorial to help you get started with python
# Further knowledge: www.learnpython.org & www.pyhon.org -> Tutorail
#####################################################################

# Python is a scripting language

# Indentation is very important

# Print statement
print "Hello, World!"


# Variables

myint = 3

myfloat = 7.0

myfloat = float(7)

mystring = "hello"

mystring1 = 'hello'

mystring2 = "Don't worry about the apostrophes"

one = 1

two = 2

three = one + two

hello = "hello"

world = "world"

helloworld = hello + " " + world

lotsofhellos = "hello" * 10

# Lists & Tuples

mylist = [1, 2, 3]

print mylist 

mylist.append(4)

mylist.append(5)

print mylist

print mylist[4] # Indexing - 0 base like C, Java, etc..

mylist[4] = 42

print mylist

print mylist[2:4] # Slicing

even_nums = [2, 4, 6, 8]

odd_nums = [1, 3, 5, 7]

all_nums = odd_nums + even_nums # Concatenation

mytuple = (1, 2, 3, 4, 5)

print mytuple

print mytuple[3] # Indexing

mytuple[3] = 17 # Error, tuples are immutable

print [1, 2, 3] * 3

# Conditions 

x = 2

print x == 2 # true

print x == 3 # false

print x < 3 # true

# If Statement

if x == 2:
	print "x = " + str(x)
	print "More stuff to print..."
	print "We are still indented so we need to print more stuff"

# Boolean operators: "and" and "or"

name = "Ben"

year = 2014

if name == "John":
	print "Your name is John"
elif name == "Ben" and year == 2014:
	print "Your name is %s and you age is %s" % (name, year)
else:
	"Hmmm, we have no idea who you are"

# The "is" and "not" operators

a = [1, 2, 3]

b = [1, 2, 3]

print a == b # true

print a is b # false, because they are not same instance

print not False # true

print (not False) == (False) # false

# For loops - think for each loops

primes = [2, 3, 5, 7]

for prime in primes:
	print prime

for i in range(0, 10):  # (inclusive,...,exclusive) i.e. N numbers
	print i

for i in range(10):  # Same thing
	print i

for j in range(5, 10):
	print j

for k in range(0, 10, 2): # Jumps by two
	print k

# While loops

count = 0

while count < 5:
	print count
	count += 1 # There is not count++ in python =(

# "break" and "continue" statements

count = 0
while True:  # Prints out 0,1,2,3,4
    print count
    count += 1
    if count >= 5:
        break

# Prints out only odd numbers - 1,3,5,7,9
for x in xrange(10):
    # Check if x is even
    if x % 2 == 0:
        continue
    print x

# Functions

def my_function():
	print "Hello from My Function!"

def my_function_with_args(name, year):
	print "Hello, %s, you are in the year %d, in case you didn't know"

my_function()

my_function_with_args("Ben", 2014)

# Classes and Objects

class MyClass:

	var = "This is a variable"

	def func(self):
		print "This is a message inside the class."

myobject = MyClass()

print myobject.var # "This is a variable"

myobject1 = MyClass()

myobject1.var = "This is a different variable"

print myobject.var
print myobject1.var # These will be different

myobject.func() # Runs the func function

#The init function, private/public vars
class MyOtherClass:

	var = "This is still a variable"

	def __init__(self):
		priv_var = "Private Variable"
		self.pub_var = "Public Var"
		print priv_var
		print self.pub_var

myobject2 = MyOtherClass() 

print myobject2.var

print  myobject2.priv_var # Error, doesn't exist in this scope

print myobject2.pub_var




