#!/bin/bash
#############################################################
# Shell Tutorial
# by: Benjamin Morgan
# Basic tutorial to help you get started using a linux shell
# Further knowledge: www.learnshell.org
#############################################################

# Text to the right of a '#' is treated as a comment

# echo / Hello World

	echo "Hello, World!"

	echo $SHELL

	echo $PS1 # Check out Ben's Pro Tips .bashrc

# Variables

	my_num=5

	my_fist_letters=ABC

	echo $my_num

	echo $my_first_letters

# man pages

	man echo # manual page on echo

# options

	echo -n "Hello, World!"

# Navigation: cd / pwd / ls

	cd ~ # change director to home directory

	echo $HOME # ~ is your home director

	pwd # print working director

	ls # list contents of current directory

	ls -l # list vertically

	man ls

	ls -la # There's the .bashrc file

	cd Documents

	cd ..

# Running a file

	chmod +x hello.sh # Make file executable

	./hello.sh

	echo 'print "hello world"' >> hello.py

	python hello.py

	chmod +x hello.py # Make python file executable

	./hello.py

	


